'addwav by df6nm 
'addwav1 180623
'compiled with FreeBasic using: ..\fbc -e addwav1.bas

'usage:
'addwav1 file.wav db=0 deg=0 delay=0
'or drag and drop file.wav over program icon
'output: sum.wav

'$ lang: "qb"
deflng a-z

db!=0 
phase!=0 
delay=0

'file1$="12090308.wav"
file1$=""
cmd$ = ltrim$(rtrim$(lcase$(command$)))
if instr(cmd$,".wav") > 0 then file1$=left$(cmd$,instr(cmd$,".wav")+3)
if file1$="" then ? "no filename provided": end
file2$=left$(file1$,len(file1$)-4)+"n.wav"

if instr(cmd$,"db=") > 0 then db!=val(right$(cmd$,len(cmd$)-instr(cmd$,"db=")-2))
if instr(cmd$,"deg=") > 0 then deg!=val(right$(cmd$,len(cmd$)-instr(cmd$,"deg=")-3))
if instr(cmd$,"delay=") > 0 then delay=val(right$(cmd$,len(cmd$)-instr(cmd$,"delay=")-5))

wflag=0
if dB!<>0 or deg!<>0 then
 wflag=1
 ampl!=10^(dB!/20)
 phi#=deg!*atn(1#)/45#
 wr!=ampl!*cos(phi#)
 wi!=ampl!*sin(phi#)
 '?wr!,wi!
end if

open file1$ for input as 1
close 1
open file1$ for binary as 1

'read header:
h$=input$(12,#1)
if left$(h$,4) <> "RIFF" or right$(h$,4)<>"WAVE" then ? "wav header missing":close 1:end
totallen=cvl(mid$(h$,5,4)) 
chunkname$=""
while chunkname$<>"data"
 chunkname$=input$(4,#1)
 chunklen=cvl(input$(4,#1))
 h$=h$+chunkname$+mkl$(chunklen)
 if chunkname$<>"data" then chunk$=input$(chunklen,#1):h$=h$+chunk$
 '? chunkname$, chunklen
wend
if chunkname$<>"data" then ?"data missing":close 1: end

hdr$=h$
nm = chunklen\8
dim ar!(nm-1),ai!(nm-1)

for n=0 to nm-1
 ar!(n)=cvs(input$(4,#1))
 ai!(n)=cvs(input$(4,#1))
 'if n<5 then ?ar!(n),ai!(n)
next n
close 1 

p1!=0
for n=0 to nm-1
 p1!=p1!+ar!(n)*ar!(n)+ai!(n)*ai!(n)
next n

if wflag then
 for n=0 to nm-1
  r2!=ar!(n)*wr!-ai!(n)*wi!
  ai!(n)=ar!(n)*wi!+ai!(n)*wr!
  ar!(n)=r2!
 next n
end if

if abs(delay) >= nm then
 for n=0 to nm-1
  ar!(n)=0:ai!(n)=0
 next n
else 
 if delay>0 then
  for n=nm-1 to delay step -1
   ar!(n)=ar!(n-delay)
   ai!(n)=ai!(n-delay)
  next n
  for n=0 to delay-1
   ar!(n)=0:ai!(n)=0
  next n
 end if
 if delay<0 then
  for n=0 to nm+delay-1
   ar!(n)=ar!(n-delay)
   ai!(n)=ai!(n-delay)
  next n
  for n=nm+delay to nm-1
   ar!(n)=0:ai!(n)=0
  next n
 end if
end if

open "sum.wav" for binary as 1
sumflag=0
if lof(1)>40 then
 sumflag=1
 h$=input$(12,#1)
 if left$(h$,4) <> "RIFF" or right$(h$,4)<>"WAVE" then sumflag=0
 totallen=cvl(mid$(h$,5,4)) 
 chunkname$=""
 while chunkname$<>"data"
  chunkname$=input$(4,#1)
  chunklen=cvl(input$(4,#1))
  h$=h$+chunkname$+mkl$(chunklen)
  if chunkname$<>"data" then chunk$=input$(chunklen,#1):h$=h$+chunk$
  '? chunkname$, chunklen
 wend
 if chunkname$<>"data" then sumflag=0
 nm2 = chunklen\8
end if

if sumflag=0 then
 nm2=0
 ?"creating new sum.wav"
end if

if nm2>nm then nm2=nm
p2!=0
for n=0 to nm2-1
 sr!=cvs(input$(4,#1))
 si!=cvs(input$(4,#1))
 'if n<5 then ?sr!,si!
 p2!=p2!+sr!*sr!+si!*si!
 ar!(n)=ar!(n)+sr!
 ai!(n)=ai!(n)+si!
next n
close 1

open "sum.wav" for output as 1
?#1,hdr$;
for n=0 to nm-1
 ?#1, mks$(ar!(n));mks$(ai!(n));
next n
close 1

p3!=0
for n=0 to nm-1
 p3!=p3!+ar!(n)*ar!(n)+ai!(n)*ai!(n)
next n

p1!=sqr(p1!/nm)
p2!=sqr(p2!/nm)
p3!=sqr(p3!/nm)
? nm;"samples ";p1!;p2!;p3!;" rms"

end

